﻿/* Copyright 2019, Kasyan Servetsky
July 12, 2019
Written by Kasyan Servetsky
http://www.kasyan.ho.com.ua
e-mail: askoldich@yahoo.com */
//======================================================================================
var scriptName = "Restore external page destinations",
doc, set, hyperlinks;

app.doScript(PreCheck, ScriptLanguage.JAVASCRIPT, undefined, UndoModes.ENTIRE_SCRIPT, "\"" + scriptName + "\" Script");

//===================================== FUNCTIONS ======================================
function Main() {
	var hyperlink, destination, destinationFile, oldDestFilePath, newDestFilePath, newDestFile,
	startTime = new Date(),
	count = 0;
	
	for (var i = hyperlinks.length - 1; i >= 0; i--) {
		hyperlink = hyperlinks[i];
		destination = hyperlink.destination;
		
		if (destination instanceof HyperlinkExternalPageDestination) {		
			oldDestFilePath = destination.documentPath.absoluteURI;
			destinationFile = destination.documentPath;
			
			if (!destinationFile.exists) {
				newDestFilePath = oldDestFilePath.replace(set.find, set.replace);
				newDestFile = new File(newDestFilePath);
		
				if (newDestFile.exists) {
					destination.documentPath = newDestFile;
					count++;
				}
			}
		}
	}

	var endTime = new Date();
	var duration = GetDuration(startTime, endTime);
	var report = "Finished.\n" + count + " hyperlink" + ((count == 1) ? " was" : "s were") + " fixed.\n(time elapsed: " + duration + ")";
	alert(report);
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CreateDialog() {
	GetDialogSettings();
	var dialog = new Window("dialog", scriptName);
	dialog.orientation = "column";
	dialog.alignChildren = "fill";
	
	var panel = dialog.add("panel", undefined, "Type here the part of the path that differs:");
	panel.orientation = "column";
	panel.alignChildren = "right";
	
	var group1 = panel.add("group");
	group1.orientation = "row";
	var findStTxt = group1.add("statictext", undefined, "Find what:");
	var findEdTxt = group1.add("edittext", undefined, set.find);
	findEdTxt.minimumSize.width = 300;
	
	var group2 = panel.add("group");
	group2.orientation = "row";
	var replaceStTxt = group2.add("statictext", undefined, "Change to:");
	var replaceEdTxt = group2.add("edittext", undefined, set.replace);
	replaceEdTxt.minimumSize.width = 300;
	
	var btnGroup = dialog.add("group");
	btnGroup.orientation = "row";
	btnGroup.alignment = "center";
	var okBtn = btnGroup.add("button", undefined, "Ok");
	var cancelBtn = btnGroup.add("button", undefined, "Cancel");

	var showDialog = dialog.show();
	if (showDialog== 1) {
		set.find = findEdTxt.text;
		set.replace = replaceEdTxt.text;
		app.insertLabel("Kas_" + scriptName, set.toSource());
		Main();
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function GetDialogSettings() {
	set = eval(app.extractLabel("Kas_" + scriptName));
	if (set == undefined) {
		set = { find: "find this", replace: "replace with this" };
	}

	return set;
}	
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function PreCheck() {
	if (app.documents.length == 0) ErrorExit("Please open a document and try again.", true);
	doc = app.activeDocument;
	if (doc.converted) ErrorExit("The current document has been modified by being converted from older version of InDesign. Please save the document and try again.", true);
	if (!doc.saved) ErrorExit("The current document has not been saved since it was created. Please save the document and try again.", true);
	hyperlinks = doc.hyperlinks;
	if (hyperlinks.length == 0) ErrorExit("No hyperlinks in the document.", true);
	CreateDialog();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function GetDuration(startTime, endTime) {
	var str;
	var duration = (endTime - startTime)/1000;
	duration = Math.round(duration);
	if (duration >= 60) {
		var minutes = Math.floor(duration/60);
		var seconds = duration - (minutes * 60);
		str = minutes + ((minutes != 1) ? " minutes, " :  " minute, ") + seconds + ((seconds != 1) ? " seconds" : " second");
		if (minutes >= 60) {
			var hours = Math.floor(minutes/60);
			minutes = minutes - (hours * 60);
			str = hours + ((hours != 1) ? " hours, " : " hour, ") + minutes + ((minutes != 1) ? " minutes, " :  " minute, ") + seconds + ((seconds != 1) ? " seconds" : " second");
		}
	}
	else {
		str = duration + ((duration != 1) ? " seconds" : " second");
	}

	return str;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ErrorExit(error, icon) {
	alert(error, scriptName, icon);
	exit();
}